BioShapeCollection
Date: 2019-10-22

org.jmol.shapebio

## Class BioShapeCollection

- java.lang.Object
- - org.jmol.shape.Shape
  - - org.jmol.shapebio.BioShapeCollection

- Direct Known Subclasses:
    Backbone, Ribbons, Rockets, Strands, Trace

      public abstract class BioShapeCollection
      extends Shape

  Mps stands for Model-Polymer-Shape When a Cartoon is instantiated with a call to setSize(), it creates an MpsShape for each BioPolymer in the model set. It is these shapes that are the real "shapes". Unlike other shapes, which are indexed by atom and throughout the entire model set, these shapes are indexed by residue and are restricted to a given BioPolymer within a given Model. Model

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) Atom[]` | `atoms`
    `BioShape[]` | `bioShapes`
    `(package private) boolean` | `isActive`
    `(package private) short` | `madDnaRna`
    `(package private) short` | `madHelixSheet`
    `(package private) short` | `madOn`
    `(package private) short` | `madTurnRandom`

    - ### Fields inherited from class org.jmol.shape.Shape

      `bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BioShapeCollection()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `findNearestAtomIndex(int xMouse, int yMouse, Atom[] closest, javajs.util.BS bsNot)`
    `BioShape` | `getBioShape(int i)`
    `(package private) int` | `getMpsShapeCount()`
    `java.lang.String` | `getShapeState()`
    `int` | `getSizeG(Group group)`
    `(package private) void` | `initialize()`
    `void` | `initModelSet()`
    `void` | `initShape()`
    `void` | `replaceGroup(Group g0, Group g1)`
    `void` | `setAtomClickability()`
    `void` | `setModelVisibilityFlags(javajs.util.BS bsModels)`
    `protected void` | `setPropBSC(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bsSelected)`
    `void` | `setProperty(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bsSelected)`
    `void` | `setShapeSizeRD(int size, RadiusData rd, javajs.util.BS bsSelected)`

    - ### Methods inherited from class org.jmol.shape.Shape

      `appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getIndexFromName, getProperty, getPropertyData, getPropShape, getShapeDetail, getSize, getTranslucentLabel, initializeShape, setModelSet, setPropS, setSize, setSizeRD, wasClicked`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### atoms

          Atom[] atoms

    - #### madOn

          short madOn

    - #### madHelixSheet

          short madHelixSheet

    - #### madTurnRandom

          short madTurnRandom

    - #### madDnaRna

          short madDnaRna

    - #### isActive

          boolean isActive

    - #### bioShapes

          public BioShape[] bioShapes

  - ### Constructor Detail

    - #### BioShapeCollection

          public BioShapeCollection()

  - ### Method Detail

    - #### initModelSet

          public final void initModelSet()

      Overrides:
        `initModelSet` in class `Shape`

    - #### initShape

          public void initShape()

      Specified by:
        `initShape` in class `Shape`

    - #### getSizeG

          public int getSizeG(Group group)

      Overrides:
        `getSizeG` in class `Shape`
      Returns:
        size

    - #### replaceGroup

          public void replaceGroup(Group g0,
                                   Group g1)

      Overrides:
        `replaceGroup` in class `Shape`

    - #### setShapeSizeRD

          public void setShapeSizeRD(int size,
                                     RadiusData rd,
                                     javajs.util.BS bsSelected)

      Overrides:
        `setShapeSizeRD` in class `Shape`

    - #### setProperty

          public void setProperty(java.lang.String propertyName,
                                  java.lang.Object value,
                                  javajs.util.BS bsSelected)

      Specified by:
        `setProperty` in class `Shape`

    - #### setPropBSC

          protected void setPropBSC(java.lang.String propertyName,
                                    java.lang.Object value,
                                    javajs.util.BS bsSelected)

    - #### getShapeState

          public java.lang.String getShapeState()

      Specified by:
        `getShapeState` in class `Shape`

    - #### initialize

          void initialize()

    - #### findNearestAtomIndex

          public void findNearestAtomIndex(int xMouse,
                                           int yMouse,
                                           Atom[] closest,
                                           javajs.util.BS bsNot)

      Overrides:
        `findNearestAtomIndex` in class `Shape`

    - #### setModelVisibilityFlags

          public void setModelVisibilityFlags(javajs.util.BS bsModels)

      Overrides:
        `setModelVisibilityFlags` in class `Shape`

    - #### setAtomClickability

          public void setAtomClickability()

      Overrides:
        `setAtomClickability` in class `Shape`

    - #### getMpsShapeCount

          int getMpsShapeCount()

    - #### getBioShape

          public BioShape getBioShape(int i)